/*---------------------------------------------------------------------------
 * libstr.c Ver1.2
 * 񑀍색Cu
 *
 * Last update : 1999/4/17
 *
 * Copyright(C) 1997-99  Yuto Ikeno  All rights reserved.
 * e-mail : mew@onbiz.net
 * homepage:http://www.onbiz.net/~mew/
 * compile: gcc -c libstr.c
----------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFint strspl (char *, char *, char);
@@@@Fchar *s1		̒O܂łi[镶
@@@@@@@char *s2		HΏە
@@@@@@@char search	
߂l@@@Fint			HΏە̏I[F0
@@@@Fs2search܂s1ɑAs2̎cɃVtg
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
int strspl(char *s1, char *s2, char search){

	int flag = 1;
	char *p = s2, *q = s2;		/*s2̈ʒuۑ*/

	if(s1 == NULL || s2 == NULL)
		return 0;

	while(*p != search && *p)	/*searchɓ钼O܂ł̒l*outɑ */
		*s1++ = *p++;

	if(!*p)						/*Y镶*/
		flag = 0;
	*s1 = '\0';				/*s1̍Ō\0*/
	p++;					/*؂蕶̕XLbv*/
	while(*p)				/*c̕A擪ɃVtg */
		*q++ = *p++;
	*q = '\0';
	return flag;
}
/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar *strsub (char *, const char *, int, int)
@@@@Fchar *s1		o͕
@@@@@@@char *s2		Ώە
@@@@@@@int start		Jnʒu
@@@@@@@int end		Iʒu
߂l@@@Fchar *		s2startend܂ł̕
@@@@Fs2startend܂łs1֔oB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char *strsub(char *s1, const char *s2, int start, int end){

	char	*p = s1;			/*s1̈ʒuۑ*/

	if(s1 == NULL || s2 == NULL)
		return NULL;

	s2 += start;				/*s2̃|C^w萔i߂*/
	while(start < end-- && *s2)	/*w蕶s1փRs[*/
		*p++ = *s2++;

	*p = '\0';

	return s1;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar *replacestring (char *, int, int)
@@@@Fchar *in		uΏە
@@@@@@@char search	
@@@@@@@char *replace	u
߂l@@@Fchar *		uI̕ւ̃|C^
@@@@FinsearchAreplaceɒuB
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char *replacestring(char *strIn, char *strSearch, char *strReplace){

	unsigned int		lenInput = 0;
	unsigned int		lenSearch = 0;
	unsigned int		lenBuffer = 0;
	unsigned int		lenReplace = 0;
	unsigned int		sizeDest = 0;
	unsigned int		len = 0;
	char*				s;
	char*				dest = NULL;

	if(strIn == NULL || strSearch == NULL || strReplace == NULL)
		return strIn;
	else if(strlen(strIn) == 0)
		return NULL;

	lenSearch = strlen(strSearch);
	lenReplace = strlen(strReplace);
	
	sizeDest = (lenReplace + (lenReplace % lenSearch)) / lenSearch;
	if((dest = (char *)malloc(strlen(strIn) * (sizeDest + 1))) == NULL)
		return NULL;
	memset( (char *)dest, 0, sizeof( dest ) );

	if(lenSearch <= 0){		/*񒷂0̏ꍇ͕̂܂ܕԂ*/
		strcpy(dest, strIn);
		return dest;
	}
	while(1){
		lenInput = strlen(strIn);		/*͕*/
		if((s = strstr(strIn, strSearch)) == NULL){
			strcat(dest, strIn);
			break;
		}
		lenBuffer = strlen(s);
		len = lenInput - lenBuffer;
		strncat(dest, strIn, len);
		strIn += len;
		strcat(dest, strReplace);
		s += lenSearch;
		strIn = s;
	}
	return dest;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
vg^CvFchar *trLower(char *)
@@@@Fchar *str		ϊΏۂ̕
߂l@@@Fchar*			ϊ̕
@@@@FstrSďɕϊ
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
char *trLower(char *str){

	char *p = str;

	while(*str++){
		if('A' <= *str && *str <= 'Z')
			*str += ' ';
	}
	str = p;

	return str;
}

/*-----------------------------------------------------------------------------
ProtoType  : char *strhead( char *s1, const char *s2, int c );
Arguments  : char s1 ... i[ϐiŒs2i[łTCYmۂĂKvj
             const char s2 ... ʌϐ
		     int c  ... icharŃLXgj
Returns    : char * ... s1̐擪AhX
Description: s2cTA܂s1֑
-----------------------------------------------------------------------------*/
char *strhead( char *s1, char *s2, int c ){

	char *p = s1;	/*ʒuۑ*/

	while( *s2 != (char)c && *s2)
		*p++ = *s2++;
	*p = '\0';

	return s1;

}
